/*
  This program is wrrtten by Rich Wang (richtop in Delphi K.Top) and it is free.
*/
//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "runningLine0.h"
#include <math.h>

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
unsigned int stipple = 0xFF00FF00, idxStipple=0x80000000;
TColor lineColor[2] = {clWhite, clRed};

void setStipple(unsigned int pattern)
{
  stipple = pattern;
}

void assignIndex(int shift)
{ if ( shift>31 )
    idxStipple = 0x80000000;
  else
    idxStipple = 0x80000000 >> shift;  // modified on Sep. 3, 2005
}

void runningLine(TCanvas *canvas, int xstart, int ystart, int xend, int yend)
{ int i, x, y, dx, dy, e, signx, signy, change, temp;

  if ( (xstart==xend) && (ystart==yend) )
    { canvas->Pixels[xstart][ystart] = lineColor[1];  // original value clRed.
      return;
    }

  signx=signy = 1;
  if ( xend<xstart ) signx = -1;
  if ( yend<ystart ) signy =- 1;

  dx = signx*(xend - xstart);
  dy = signy*(yend - ystart);
  if ( dy<=dx ) change = 0;
  else { change = 1;
         temp = dx;  dx = dy;  dy = temp;
       }

  e = 2*dy - dx;
  x = xstart;  y = ystart;
  for (i=0; i<=dx; i++)
     { if ( stipple & idxStipple )            // foreground
         canvas->Pixels[x][y] = lineColor[1];
       else
         canvas->Pixels[x][y] = lineColor[0]; // background

       idxStipple >>= 1;
       if ( idxStipple==0 ) idxStipple = 0x80000000;

       while ( e>=0 )
         { if ( change==0 ) y += signy;
           else x += signx;
           e -= 2*dx;
         }
       if ( change==0 ) x += signx;
       else y += signy;
       e += 2*dy;
     }
}

// --------------
struct Point2D
{ int x, y;
};
Point2D pts[] = { {0,1},  // show ""
                  {0,0},{9,0},{9,1},{5,1},{5,3},  {7,3},{7,4},{5,4},{5,6},{8,6},
                  {8,7},{1,7},{1,6},{4,6},{4,1},  {3,1},{3,3},{2,3},{2,1},{0,1}
                };
void __fastcall TForm1::Button1Click(TObject *Sender)
{ int xstart=10, ystart=10, xend=300, yend=400;

  static int index=0;

  assignIndex(index);
  runningLine(Canvas, xstart, ystart, xend, yend);
  ++index;
  if ( index>31 ) index = 0;

}
//---------------------------------------------------------------------------
void runningShow(TCanvas *canvas)
{ int len, x0=130, y0=280;
  float scale = 30;
  static int times=0;
  len = sizeof(pts) / sizeof(pts[0]);
  if ( times==0 )
    { for (int k=0; k<len; ++k)
         { pts[k].x *= scale;
           pts[k].y *= scale;
         }
      ++times;
    }
  //for (int k=0; k<20; ++k)
     { for (int p=0; p<len-1; ++p)
         { runningLine(canvas, x0+pts[p].x, y0-pts[p].y, x0+pts[p+1].x, y0-pts[p+1].y);
         }
       //Sleep(150);
     }
}
const float PI=3.141592653;
float ptCir[16], cx, cy;

void getCenter()
{ float scale=30;
  int len;

  cx=cy = 0.0;
  len = sizeof(pts) / sizeof(pts[0]);

  for (int k=0; k<len; ++k)
     { cx += pts[k].x;
       cy += pts[k].y;
     }
  cx /= len;
  cy /= len;
}
void runningCircle(TCanvas *canvas, int x, int y, int r)
{ //static bool firstTime=true; // could be used to assign an initial value
  static int cx, cy, radius;
  if ( (cx!=x) || (cy!=y) || (r!=radius) )
    { float deg = PI / 4.;
      cx = x;  cy = y;  radius = r;
      for (int k=0; k<8; ++k)
         { ptCir[2*k  ] = cx + radius * cos(k*deg);
           ptCir[2*k+1] = cy + radius * sin(k*deg);
         }
    }
  for (int p=0; p<8-1; ++p)
     { runningLine(canvas, ptCir[2*p], ptCir[2*p+1], ptCir[2*p+2], ptCir[2*p+3]);
     }
  runningLine(canvas, ptCir[14], ptCir[15], ptCir[0], ptCir[1]);
}

void __fastcall TForm1::Button2Click(TObject *Sender)
{
  Timer1->Enabled = !Timer1->Enabled;
  if ( Timer1->Enabled )
    Button2->Caption = "Stop";
  else
    Button2->Caption = "Start";
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer1Timer(TObject *Sender)
{ static int shift1=0, shift2=0;

  Application->ProcessMessages();

  assignIndex(shift1);
  runningShow(Canvas);
  shift1 = (shift1+2) % 32;

  int radius=180;
  getCenter();  // to get the center coordinates of the ""
  assignIndex(shift2);
  runningCircle(Canvas, 140+cx, 102+cy, radius);
  shift2 = (shift2+4) % 32;
}
//---------------------------------------------------------------------------
